;EMUCMDS.INC (C)1993 Johannes Bjerregaard. All rights reserved.
;--------------------------------------------------------------
;Command interface for MIDIEMU module of SMFP. Valid for single-driver
;version.
;
SMFP_INITIALIZE        equ         0
SMFP_LOADTUNE          equ         1
SMFP_PUTMIDIDATA       equ         2
SMFP_ISR               equ         3
SMF_LOADTUNE           equ         4
SMF_ISR                equ         5
SMF_STOPTUNE           equ         6

;SMFP_INITIALIZE:
;---------------
;Initialize driver & hardware. Call this once before using any other
;funtions.
;Automatically called from within SMF_LOADTUNE (when restarting a MIDI file)
;and SMF_STOPTUNE (when aborting the playback of a MIDI file).
;No parameters.
;No return value.

;SMFP_LOADTUNE:
;-------------
;Initialize MFP data for a tune. Call this once to initialize a tune.
;Parameters : AX = segment of MFP (patch file)
;Returns nothing.

;SMFP_PUTMIDIDATA:
;----------------
;The MIDI data dispatch function.
;Parameters : AL = MIDI data byte to put.
;No return value.

;SMFP_ISR:
;--------
;This function must be called 70 times per second. Updates realtime sound.
;No parameters.
;No return value.

;SMF_ISR:
;-------
;This function must be called 70 times per second. Automatically passes
;control to SMFP_ISR after completion. This function plays the SMF.
;No parameters.
;No return value.

;SMF_LOADTUNE:
;------------
;Initialize SMF data (the MIDI file). Call this every time a tune needs
;to be restarted, after setting up the MFP (patch file) using SMFP_LOADTUNE.
;Parameters : AX = segment address of standard MIDI file to play.
;No return value.

;SMF_STOPTUNE:
;------------
;Abort playing the currently active tune.
;No parameters.
;No return value.
