;MIDIMSG.INC - (C)1993 Johannes Bjerregaard. All rights reserved.
;----------------------------------------------------------------
;
;Include file defining standard MIDI message name equvivalents
;

;MIDI command headers

CMD_NOTEOFF         equ       080h ;note off with velocity
CMD_NOTE            equ       090h ;note on
CMD_POLY_KEY_PRES   equ       0a0h ;poly key pressure
CMD_CC              equ       0b0h ;control change or channel mode message
CMD_PROGRAM_CHANGE  equ       0c0h ;program change
CMD_CHANNEL_PRES    equ       0d0h ;channel pressure
CMD_PITCH_BEND      equ       0e0h ;pitch bend
CMD_ACTIVE_SENSING  equ       0feh ;active sensing
CMD_EXCLUSIVE       equ       0f0h ;system exclusive
CMD_EXCLUSIVE_END   equ       0f7h ;end of system exclusive

;Control change messages, expected after receiving a CMD_CC

CC_BANK_SELECT      equ       000h ;bank select control
CC_BANK_SELECT2     equ       020h ;bank select (dummy bank of 0)
CC_MODULATION       equ       001h ;modulation
CC_PORTAMENTO_TIME  equ       005h ;portamento time
CC_DATA_ENTRY_MSB   equ       006h ;data entry of RPN(/NRPN) (msb)
CC_DATA_ENTRY_LSB   equ       026h ;data entry of RPN (lsb)
CC_VOLUME           equ       007h ;volume change
CC_PANPOT           equ       00ah ;panpot
CC_EXPRESSION       equ       00bh ;expression
CC_HOLD1            equ       040h ;hold pedal
CC_PORTAMENTO       equ       041h ;portamento
CC_SOSTENUTO        equ       042h ;sostenuto
CC_SOFT             equ       043h ;soft
CC_LGC              equ       054h ;legato control
CC_EFFECT1_DEPTH    equ       05bh ;reverb send depth
CC_EFFECT3_DEPTH    equ       05dh ;chorus send depth
CC_NRPN_MSB         equ       063h ;NRPN msb
CC_NRPN_LSB         equ       062h ;NRPN lsb
CC_RPN_MSB          equ       065h ;RPN msb
CC_RPN_LSB          equ       064h ;RPN lsb

;Channel mode messages, expected after receiving a CMD_CC

CM_ALL_SOUNDS_OFF   equ       078h ;all sounds off
CM_RESET_ALL_CTRLS  equ       079h ;reset all controllers
CM_ALL_NOTES_OFF    equ       07bh ;all notes off
CM_OMNI_OFF         equ       07ch ;omni off
CM_OMNI_ON          equ       07dh ;omni on
CM_MONO             equ       07eh ;mono
CM_POLY             equ       07fh ;poly

;MIDI flow control constants - not MIDI messages
;Values for expected, based on previously received value

EXP_ANYTHING        equ       000h ;anything may come up
EXP_NOTE            equ       001h ;expecting a note number
EXP_NOTEOFF_NOTE    equ       002h ;expecting a note off note
EXP_VELOCITY        equ       003h ;velocity
EXP_NOTEOFF_VELOCITY equ      004h ;note off velocity
EXP_POLY_PRES       equ       005h ;poly pressure value
EXP_CC_MSG          equ       006h ;control change message
EXP_CC_VALUE        equ       007h ;control change value
EXP_PROGRAM         equ       008h ;program change value
EXP_CHANNEL_PRES    equ       009h ;channel pressure value
EXP_PITCH_BEND_LSB  equ       00ah ;pitch bend lsb value
EXP_PITCH_BEND_MSB  equ       00bh ;pitch bend msb value
EXP_EXCLUSIVE_END   equ       00ch ;waiting for exclusive end

;end of file
