;Frequency data comes in 2-word packets. The first word specify a frequency
;value which is relative to the previous value if bit 15 of the repeat count
;is clear or absolute if set. The second word indicates the number of frames
;that the packet is to be repeated (zero means that the packet is only
;played once). If the first word of the packet is set to 0ffffh, the second
;word specifies a loop index relative to the start of the data segment, and
;the frequency data will loop.



;Level data comes in 2-byte packets. The first byte specifies a data value,
;the second one a repeat count. If bit 7 of the repeat count is set, the
;data value is absolute, otherwise it's relative to the previous level.

.model large,c

include version.inc
include adlib.inc

IFDEF ENABLESFX

.fardata SFX_DATA
sfxofftab label word   ;offsettabel - et word for hver sfx.
                       ;denne tabel kommer i offset 0 i sfx-segmentet.

          dw    sfx1start      ;syn gentag middel op+ned bld
          dw    sfx2start      ;syn gentag hurtigt stig skarp
          dw    sfx3start      ;telefon op + disintegrate ekko
          dw    sfx4start      ;syn gentag middel stig disp op bld
          dw    sfx5start      ;syn gentag hurtigt stig bounce bld
          dw    sfx6start      ;rumlende stj ekko
          dw    sfx7start      ;klirren svag
          dw    sfx8start      ;rumlende stj baglns
          dw    sfx9start      ;klirren baglns
          dw    sfxastart      ;syn chunk! hurtig fald dyb sqr
          dw    sfxbstart      ;snork
          dw    sfxcstart      ;kort luftagtig "wha!"
          dw    sfxdstart      ;hult dump som en der lander p platform?
          dw    sfxestart      ;underlig ubeskrivelig fesen lyd
          dw    sfxfstart      ;lidt a la en sten der flyttes
          dw    sfx10start     ;pling
          dw    sfx11start     ;"hop"
          dw    sfx12start     ;lasergun med ekko
          dw    sfx13start     ;laserblender
          dw    sfx14start     ;opadgende flut
          dw    sfx15start     ;luftagtig "fahawa!"
          dw    sfx16start     ;splash
          dw    sfx17start     ;en til "awaa!"
          dw    sfx18start     ;motorsavskvrn
          dw    sfx19start     ;metal click
          dw    sfx1astart     ;siren
          dw    sfx1bstart     ;small explosion
          dw    sfx1cstart     ;syn tynd hj gentag hurtigt stig bld
          dw    sfx1dstart     ;mr. mixer
          dw    sfx1estart     ;lang random
          dw    sfx1fstart     ;bouncing

;----------------------------------------------------------------------------
;'A'




sfx1start label sfxheader
          db    001h,001h      ;multi etc.
          db    030h,020h      ;level
          db    0f0h,0f4h      ;attack/decay
          db    0f0h,0f6h      ;sustain/release
          db    002h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx1fq         ;frequency data
          dw    sfx1out        ;carrier level data
          dw    70             ;keyoff time
          dw    80             ;end of sound time


sfx1fq    label word
sfx1fql   label word
          dw    1800h,8000h      ;
          dw    -172,4           ;
          dw    172,5
          dw    0ffffh,sfx1fql  ;loop from beginning

sfx1out   label byte
          db    000h,080h      ;level, number of repeats
sfx1outl  label byte
          db    000h,07fh
          dw    0ffffh         ;loop
          dw    sfx1outl       ;loop point



;----------------------------------------------------------------------------
;'B'



sfx2start label sfxheader
          db    001h,001h      ;multi etc.
          db    017h,020h      ;level
          db    0f0h,0f4h      ;attack/decay
          db    0f0h,0f6h      ;sustain/release
          db    001h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx2fq         ;frequency data
          dw    sfx2out        ;carrier level data
          dw    70             ;keyoff time
          dw    80             ;end of sound time


sfx2fq    label word
sfx2fql   label word
          dw    1400h,8000h      ;
          dw    162,4
          dw    0ffffh,sfx2fql  ;loop from beginning

sfx2out   label byte
          db    000h,080h      ;level, number of repeats
sfx2outl  label byte
          db    000h,07fh
          dw    0ffffh         ;loop
          dw    sfx2outl       ;loop point



;----------------------------------------------------------------------------
;'C'



sfx3start label sfxheader
          db    00bh,004h      ;multi etc.
          db    009h,020h      ;level
          db    0f0h,033h      ;attack/decay
          db    0f0h,0f5h      ;sustain/release
          db    001h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx3fq         ;frequency data
          dw    sfx3out        ;carrier level data
          dw    140            ;keyoff time
          dw    170            ;end of sound time


sfx3fq    label word
sfx3fql   label word
          dw    1ce0h,8000h    ;
          dw    -130,0
          dw    0,0eh
          dw    -352,0
          dw    -130,0
          dw    0,0eh
          dw    0ffffh,sfx3fql ;loop from beginning

sfx3out   label byte
          db    000h,080h      ;level, number of repeats
sfx3outl  label byte
          db    000h,80h
          db    03fh,8fh
          dw    0ffffh         ;loop
          dw    sfx3outl       ;loop point



;----------------------------------------------------------------------------
;'D'



sfx4start label sfxheader
          db    001h,001h      ;multi etc.
          db    020h,020h      ;level
          db    0f0h,030h      ;attack/decay
          db    0f0h,0f6h      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx4fq         ;frequency data
          dw    sfx4out        ;carrier level data
          dw    100            ;keyoff time
          dw    130            ;end of sound time


sfx4fq    label word
          dw    0c00h,8000h      ;
sfx4fql   label word
          dw    155,9
          dw    -0e00h,0
          dw    0ffffh,sfx4fql  ;loop from beginning

sfx4out   label byte
          db    6h,080h      ;level, number of repeats
sfx4outl  label byte
          db    000h,07fh
          dw    0ffffh         ;loop
          dw    sfx4outl       ;loop point





;----------------------------------------------------------------------------
;'E'



sfx5start label sfxheader
          db    004h,003h      ;multi etc.
          db    020h,010h      ;level
          db    0f0h,0f4h      ;attack/decay
          db    0f0h,0f5h      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx5fq         ;frequency data
          dw    sfx5out        ;carrier level data
          dw    50            ;keyoff time
          dw    70            ;end of sound time


sfx5fq    label word
          dw    1200h,8000h      ;
sfx5fql   label word
          dw    -223,2
          dw    0800h,0
          dw    0ffffh,sfx5fql  ;loop from beginning

sfx5out   label byte
          db    000h,080h      ;level, number of repeats
sfx5outl  label byte
          db    000h,07fh
          dw    0ffffh         ;loop
          dw    sfx5outl       ;loop point







;----------------------------------------------------------------------------
;'F'



sfx6start label sfxheader
          db    004h,003h      ;multi etc.
          db    03ah,010h      ;level
          db    0f0h,0f0h      ;attack/decay
          db    0f0h,0f6h      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx6fq         ;frequency data
          dw    sfx6out        ;carrier level data
          dw    50            ;keyoff time
          dw    70            ;end of sound time


sfx6fq    label word
          dw    0680h,8000h      ;
sfx6fql   label word
          dw    -150,1
          dw    190,1
          dw    -100,1
          dw    100,1
          dw    -130,1
          dw    110,1
          dw    -170,1
          dw    130,1
          dw    -100,1
          dw    110,1
          dw    -150,1
          dw    190,1
          dw    -130,1
          dw    100,1
          dw    -170,1
          dw    130,1
          dw    0ffffh,sfx6fql  ;loop from beginning

sfx6out   label byte
          db    000h,080h      ;level, number of repeats
sfx6outl  label byte
          db    0,12
          db    2,5
          dw    0ffffh         ;loop
          dw    sfx6outl       ;loop point






;----------------------------------------------------------------------------
;'G'



sfx7start label sfxheader
          db    005h,007h     ;multi etc.
          db    018h,010h     ;level
          db    0f0h,0f4h     ;attack/decay
          db    0f0h,0f6h     ;sustain/release
          db    002h,000h     ;waveform
          db    000h          ;feedback/connection
          dw    sfx7fq        ;frequency data
          dw    sfx7out       ;carrier level data
          dw    50            ;keyoff time
          dw    70            ;end of sound time


sfx7fq    label word
          dw    1c00h,8000h   ;
sfx7fql   label word
          dw    -450,0
          dw    -130,0
          dw    360,0
          dw    -130,0
          dw    360,0
          dw    -100,0
          dw    0ffffh,sfx7fql;loop from beginning

sfx7out   label byte
          db    018h,080h     ;level, number of repeats
sfx7outl  label byte
          db    0,12
          db    2,5
          dw    0ffffh        ;loop
          dw    sfx7outl      ;loop point






;----------------------------------------------------------------------------
;'H'



sfx8start label sfxheader
          db    004h,003h      ;multi etc.
          db    03ah,010h      ;level
          db    0f0h,0f0h      ;attack/decay
          db    0f0h,0f6h      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx8fq         ;frequency data
          dw    sfx8out        ;carrier level data
          dw    50            ;keyoff time
          dw    70            ;end of sound time


sfx8fq    label word
          dw    0680h,8000h      ;
sfx8fql   label word
          dw    -150,1
          dw    190,1
          dw    -100,1
          dw    100,1
          dw    -130,1
          dw    110,1
          dw    -170,1
          dw    130,1
          dw    -100,1
          dw    110,1
          dw    -150,1
          dw    190,1
          dw    -130,1
          dw    100,1
          dw    -170,1
          dw    130,1
          dw    0ffffh,sfx8fql  ;loop from beginning

sfx8out   label byte
          db    40,080h      ;level, number of repeats
          db    -1,26
          db    0,10
sfx8outl  label byte
          db    1,13
          db    0,3
          db    13,2
          dw    0ffffh         ;loop
          dw    sfx8outl       ;loop point






;----------------------------------------------------------------------------
;'I'



sfx9start label sfxheader
          db    005h,007h     ;multi etc.
          db    018h,010h     ;level
          db    0f0h,0f4h     ;attack/decay
          db    0f0h,0f6h     ;sustain/release
          db    002h,000h     ;waveform
          db    000h          ;feedback/connection
          dw    sfx9fq        ;frequency data
          dw    sfx9out       ;carrier level data
          dw    50            ;keyoff time
          dw    70            ;end of sound time


sfx9fq    label word
          dw    1c00h,8000h   ;
sfx9fql   label word
          dw    -450,0
          dw    -130,0
          dw    360,0
          dw    -130,0
          dw    360,0
          dw    -100,0
          dw    0ffffh,sfx9fql;loop from beginning

sfx9out   label byte
          db    59,080h      ;level, number of repeats
sfx9outl  label byte
          db    -3,13
          db    0,3
          db    39,0
          dw    0ffffh         ;loop
          dw    sfx9outl       ;loop point




;----------------------------------------------------------------------------
;'J'



sfxastart label sfxheader
          db    000h,001h     ;multi etc.
          db    000h,010h     ;level
          db    0f0h,0f5h     ;attack/decay
          db    0f0h,0f8h     ;sustain/release
          db    002h,000h     ;waveform
          db    000h          ;feedback/connection
          dw    sfxafq        ;frequency data
          dw    sfxaout       ;carrier level data
          dw    8             ;keyoff time
          dw    10            ;end of sound time


sfxafq    label word
          dw    0c00h,8000h   ;
sfxafql   label word
          dw    -160,30
          dw    0ffffh,sfxafql;loop from beginning

sfxaout   label byte
          db    10,080h      ;level, number of repeats
sfxaoutl  label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfxaoutl       ;loop point




;----------------------------------------------------------------------------
;'K'



sfxbstart label sfxheader
          db    001h,004h      ;multi etc.
          db    00fh,000h      ;level
          db    0f0h,040h      ;attack/decay
          db    0f0h,0f5h      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfxbfq         ;frequency data
          dw    sfxbout        ;carrier level data
          dw    30            ;keyoff time
          dw    40            ;end of sound time


sfxbfq    label word
sfxbfql   label word
          dw    0480h,8000h      ;
          dw    110,2
          dw    0480h,8000h      ;
          dw    120,2
          dw    0480h,8000h      ;
          dw    130,2
          dw    0480h,8000h      ;
          dw    140,2
          dw    0480h,8000h      ;
          dw    150,2
          dw    0480h,8000h      ;
          dw    160,2
          dw    0480h,8000h      ;
          dw    170,2
          dw    0480h,8000h      ;
          dw    177,2
          dw    0480h,8000h      ;
          dw    183,2
          dw    0480h,8000h      ;
          dw    192,2
          dw    0480h,8000h      ;
          dw    200,2
          dw    0,7fffh
          dw    0ffffh,sfxbfql  ;loop from beginning

sfxbout   label byte
          db    000h,080h      ;level, number of repeats
sfxboutl  label byte
          db    0,12
          db    2,5
          dw    0ffffh         ;loop
          dw    sfxboutl       ;loop point





;----------------------------------------------------------------------------
;'L'



sfxcstart label sfxheader
          db    00bh,00ah      ;multi etc.
          db    010h,010h      ;level
          db    050h,066h      ;attack/decay
          db    0f0h,0f7h      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfxcfq         ;frequency data
          dw    sfxcout        ;carrier level data
          dw    5              ;keyoff time
          dw    10             ;end of sound time


sfxcfq    label word
          dw    0580h,8000h    ;
sfxcfql   label word
          dw    30,3
          dw    -20,30
          dw    0ffffh,sfxcfql ;loop from beginning

sfxcout   label byte
          db    0,080h         ;level, number of repeats
sfxcoutl  label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfxcoutl       ;loop point




;----------------------------------------------------------------------------
;'M'



sfxdstart label sfxheader
          db    001h,001h      ;multi etc.
          db    03fh,010h      ;level
          db    0f0h,0f2h      ;attack/decay
          db    0f0h,0f6h      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfxdfq         ;frequency data
          dw    sfxdout        ;carrier level data
          dw    2              ;keyoff time
          dw    15             ;end of sound time


sfxdfq    label word
sfxdfql   label word
          dw    0d40h,8000h    ;
          dw    -40,4
          dw    0,4
          dw    0ffffh,sfxdfql ;loop from beginning

sfxdout   label byte
          db    0,080h         ;level, number of repeats
sfxdoutl  label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfxdoutl       ;loop point





;----------------------------------------------------------------------------
;'N'



sfxestart label sfxheader
          db    003h,007h      ;multi etc.
          db    00ah,000h      ;level
          db    0f0h,0f4h      ;attack/decay
          db    0f0h,0f6h      ;sustain/release
          db    002h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfxefq         ;frequency data
          dw    sfxeout        ;carrier level data
          dw    10             ;keyoff time
          dw    30             ;end of sound time


sfxefq    label word
          dw    0340h,8000h    ;
sfxefql   label word
          dw    -20,9
          dw    100,0
          dw    0ffffh,sfxefql ;loop from beginning

sfxeout   label byte
          db    10,080h         ;level, number of repeats
sfxeoutl  label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfxeoutl       ;loop point




;----------------------------------------------------------------------------
;'O'



sfxfstart label sfxheader
          db    005h,003h      ;multi etc.
          db    01fh,010h      ;level
          db    049h,0f0h      ;attack/decay
          db    0f6h,0f6h      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfxffq         ;frequency data
          dw    sfxfout        ;carrier level data
          dw    50            ;keyoff time
          dw    70            ;end of sound time


sfxffq    label word
          dw    0680h,8000h      ;
sfxffql   label word
          dw    -150,1
          dw    190,1
          dw    -100,1
          dw    100,1
          dw    -130,1
          dw    110,1
          dw    -170,1
          dw    130,1
          dw    -100,1
          dw    110,1
          dw    -150,1
          dw    190,1
          dw    -130,1
          dw    100,1
          dw    -170,1
          dw    130,1
          dw    0ffffh,sfxffql  ;loop from beginning

sfxfout   label byte
          db    40,080h      ;level, number of repeats
          db    -3,9
          db    0,03h
sfxfoutl  label byte
          db    13,3
          db    -3,13
          db    0,3
          dw    0ffffh         ;loop
          dw    sfxfoutl       ;loop point




;----------------------------------------------------------------------------
;'P'



sfx10start label sfxheader
          db    005h,001h      ;multi etc.
          db    01ah,010h      ;level
          db    030h,095h      ;attack/decay
          db    0f0h,0f6h      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx10fq         ;frequency data
          dw    sfx10out        ;carrier level data
          dw    20            ;keyoff time
          dw    30            ;end of sound time


sfx10fq    label word
          dw    1400h,8000h      ;
sfx10fql   label word
          dw    172,2
          dw    -172,2
          dw    0ffffh,sfx10fql  ;loop from beginning

sfx10out   label byte
          db    0,080h      ;level, number of repeats
sfx10outl  label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfx10outl       ;loop point



;----------------------------------------------------------------------------
;'Q'



sfx11start label sfxheader
          db    00bh,00ah      ;multi etc.
          db    010h,010h      ;level
          db    050h,06ah      ;attack/decay
          db    0f0h,08ah      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx11fq        ;frequency data
          dw    sfx11out       ;carrier level data
          dw    11              ;keyoff time
          dw    13             ;end of sound time


sfx11fq    label word
          dw    840h,8000h      ;
sfx11fql   label word
          dw    42,5
          dw    0ffffh,sfx11fql  ;loop from beginning

sfx11out   label byte
          db    0,080h      ;level, number of repeats
sfx11outl  label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfx11outl       ;loop point





;----------------------------------------------------------------------------
;'R'



sfx12start label sfxheader
          db    007h,005h      ;multi etc.
          db    015h,010h      ;level
          db    0f0h,0f6h      ;attack/decay
          db    0f0h,0f6h      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx12fq        ;frequency data
          dw    sfx12out       ;carrier level data
          dw    20             ;keyoff time
          dw    30             ;end of sound time


sfx12fq   label word
sfx12fql  label word
          dw    1400h,8000h    ;
          dw    -180,8
          dw    0ffffh,sfx12fql;loop from beginning

sfx12out  label byte
          db    8,080h         ;level, number of repeats
sfx12outl label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfx12outl      ;loop point



;----------------------------------------------------------------------------
;'S'



sfx13start label sfxheader
          db    001h,003h      ;multi etc.
          db    012h,010h      ;level
          db    0f0h,0f5h      ;attack/decay
          db    0f0h,0f7h      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx13fq        ;frequency data
          dw    sfx13out       ;carrier level data
          dw    40             ;keyoff time
          dw    48             ;end of sound time


sfx13fq   label word
          dw    1a00h,8000h    ;
sfx13fql  label word
          dw    -190,1
          dw    250,0
          dw    0ffffh,sfx13fql;loop from beginning

sfx13out  label byte
          db    10,080h         ;level, number of repeats
sfx13outl label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfx13outl      ;loop point




;----------------------------------------------------------------------------
;'T'



sfx14start label sfxheader
          db    002h,003h      ;multi etc.
          db    01fh,010h      ;level
          db    0f0h,0f5h      ;attack/decay
          db    0f0h,0f7h      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx14fq        ;frequency data
          dw    sfx14out       ;carrier level data
          dw    20             ;keyoff time
          dw    28             ;end of sound time


sfx14fq   label word
sfx14fql  label word
          dw    344,8000h    ;
          dw    180,10
          dw    0ffffh,sfx14fql;loop from beginning

sfx14out  label byte
          db    10,080h         ;level, number of repeats
sfx14outl label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfx14outl      ;loop point




;----------------------------------------------------------------------------
;'U'



sfx15start label sfxheader
          db    00bh,00ah      ;multi etc.
          db    020h,010h      ;level
          db    050h,060h      ;attack/decay
          db    0f0h,08ah      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx15fq        ;frequency data
          dw    sfx15out       ;carrier level data
          dw    25              ;keyoff time
          dw    30             ;end of sound time


sfx15fq    label word
          dw    08a0h,8000h      ;
sfx15fql   label word
          dw    62,5
          dw    -90,2
          dw    30,4
          dw    -30,7
          dw    0,07fffh
          dw    0ffffh,sfx15fql  ;loop from beginning

sfx15out   label byte
          db    10,080h      ;level, number of repeats
sfx15outl  label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfx15outl       ;loop point


;----------------------------------------------------------------------------
;'V'



sfx16start label sfxheader
          db    000h,00ah      ;multi etc.
          db    000h,010h      ;level
          db    0f0h,050h      ;attack/decay
          db    0f0h,0f5h      ;sustain/release
          db    000h,000h      ;waveform
          db    00eh           ;feedback/connection
          dw    sfx16fq        ;frequency data
          dw    sfx16out       ;carrier level data
          dw    55              ;keyoff time
          dw    70             ;end of sound time


sfx16fq    label word
          dw    18a0h,8000h      ;
sfx16fql   label word
          dw    0,07fffh
          dw    0ffffh,sfx15fql  ;loop from beginning

sfx16out   label byte
          db    18,080h      ;level, number of repeats
sfx16outl  label byte
          db    0,15
          db    3,4
          dw    0ffffh         ;loop
          dw    sfx16outl       ;loop point




;----------------------------------------------------------------------------
;'W'



sfx17start label sfxheader
          db    00bh,00ah      ;multi etc.
          db    020h,010h      ;level
          db    050h,060h      ;attack/decay
          db    0f0h,08ah      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx17fq        ;frequency data
          dw    sfx17out       ;carrier level data
          dw    25              ;keyoff time
          dw    30             ;end of sound time


sfx17fq    label word
          dw    0840h,8000h      ;
sfx17fql   label word
          dw    42,7
          dw    -60,8
          dw    -130,0
          dw    -10,1
          dw    0,07fffh
          dw    0ffffh,sfx17fql  ;loop from beginning

sfx17out   label byte
          db    10,080h      ;level, number of repeats
sfx17outl  label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfx17outl       ;loop point



;----------------------------------------------------------------------------
;'X'



sfx18start label sfxheader
          db    005h,001h      ;multi etc.
          db    018h,010h      ;level
          db    0f0h,0f0h      ;attack/decay
          db    0f0h,0f5h      ;sustain/release
          db    000h,003h      ;waveform
          db    008h           ;feedback/connection
          dw    sfx18fq        ;frequency data
          dw    sfx18out       ;carrier level data
          dw    55              ;keyoff time
          dw    80             ;end of sound time


sfx18fq   label word
          dw    08a0h,8000h      ;
sfx18fql  label word
          dw    20,15
          dw    -30,1
          dw    40,1
          dw    -40,1
          dw    30,1
          dw    -30,1
          dw    30,1
          dw    -40,1
          dw    30,1
          dw    -30,1
          dw    40,1
          dw    -40,1
          dw    30,1
          dw    -30,1
          dw    40,1
          dw    -40,1
          dw    40,1
          dw    -30,1
          dw    40,1
          dw    -40,1
          dw    30,1
          dw    -40,15
          dw    0ffffh,sfx18fql  ;loop from beginning

sfx18out   label byte
          db    10,080h      ;level, number of repeats
sfx18outl  label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfx18outl       ;loop point




;----------------------------------------------------------------------------
;'Y'


sfx19start label sfxheader
          db    004h,001h      ;multi etc.
          db    018h,010h      ;level
          db    0f3h,0f7h      ;attack/decay
          db    0f0h,0f6h      ;sustain/release
          db    000h,000h      ;waveform
          db    008h           ;feedback/connection
          dw    sfx19fq        ;frequency data
          dw    sfx19out       ;carrier level data
          dw    10             ;keyoff time
          dw    16             ;end of sound time


sfx19fq   label word
sfx19fql  label word
          dw    18a0h,8fffh      ;
          dw    0ffffh,sfx19fql  ;loop from beginning

sfx19out   label byte
          db    10,080h      ;level, number of repeats
sfx19outl  label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfx19outl       ;loop point


;----------------------------------------------------------------------------
;'Z'


sfx1astart label sfxheader
          db    001h,001h      ;multi etc.
          db    028h,010h      ;level
          db    0f0h,0f1h      ;attack/decay
          db    0f0h,0f4h      ;sustain/release
          db    002h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx1afq        ;frequency data
          dw    sfx1aout       ;carrier level data
          dw    270            ;keyoff time
          dw    300            ;end of sound time


sfx1afq   label word
          dw    14a0h,8000h      ;
sfx1afql  label word
          dw    70,14
          dw    -70,14
          dw    0ffffh,sfx1afql  ;loop from beginning

sfx1aout   label byte
          db    10,080h      ;level, number of repeats
sfx1aoutl  label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfx1aoutl       ;loop point


;----------------------------------------------------------------------------
;'0'



sfx1bstart label sfxheader
          db    000h,004h      ;multi etc.
          db    020h,010h      ;level
          db    0f0h,0f6h      ;attack/decay
          db    0f0h,0f6h      ;sustain/release
          db    000h,000h      ;waveform
          db    00eh           ;feedback/connection
          dw    sfx1bfq         ;frequency data
          dw    sfx1bout        ;carrier level data
          dw    40            ;keyoff time
          dw    60            ;end of sound time


sfx1bfq    label word
          dw    0640h,8000h      ;
sfx1bfql   label word
          dw    -150,1
          dw    190,1
          dw    -100,1
          dw    100,1
          dw    -130,1
          dw    110,1
          dw    -170,1
          dw    130,1
          dw    -100,1
          dw    110,1
          dw    -150,1
          dw    190,1
          dw    -130,1
          dw    100,1
          dw    -170,1
          dw    130,1
          dw    0ffffh,sfx1bfql  ;loop from beginning

sfx1bout   label byte
          db    000h,080h      ;level, number of repeats
sfx1boutl  label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfx1boutl       ;loop point




;----------------------------------------------------------------------------
;'1'



sfx1cstart label sfxheader
          db    001h,001h      ;multi etc.
          db    030h,010h      ;level
          db    0f0h,045h      ;attack/decay
          db    0f0h,0f5h      ;sustain/release
          db    002h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx1cfq         ;frequency data
          dw    sfx1cout        ;carrier level data
          dw    20            ;keyoff time
          dw    30            ;end of sound time


sfx1cfq    label word
          dw    1940h,8000h      ;
sfx1cfql   label word
          dw     170,3
          dw     -170,3
          dw    0ffffh,sfx1cfql  ;loop from beginning

sfx1cout   label byte
          db    10h,080h      ;level, number of repeats
sfx1coutl  label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfx1coutl       ;loop point





;----------------------------------------------------------------------------
;'2'



sfx1dstart label sfxheader
          db    001h,001h      ;multi etc.
          db    000h,010h      ;level
          db    0f0h,050h      ;attack/decay
          db    0f0h,0f6h      ;sustain/release
          db    001h,000h      ;waveform
          db    00ah           ;feedback/connection
          dw    sfx1dfq         ;frequency data
          dw    sfx1dout        ;carrier level data
          dw    30            ;keyoff time
          dw    40            ;end of sound time


sfx1dfq    label word
          dw    0840h,8000h      ;
sfx1dfql   label word
          dw     70,1
          dw     -100,1
          dw     -70,1
          dw     100,1
          dw     30,1
          dw     -50,1
          dw     -30,1
          dw     30,1
          dw    0ffffh,sfx1dfql  ;loop from beginning

sfx1dout   label byte
          db    10,080h      ;level, number of repeats
sfx1doutl  label byte
          db    0,07fh
          dw    0ffffh         ;loop
          dw    sfx1doutl       ;loop point



;----------------------------------------------------------------------------
;'3'
sfx1estart label sfxheader
          db    006h,001h      ;multi etc.
          db    010h,010h      ;level
          db    0f0h,0f2h      ;attack/decay
          db    0f0h,0f4h      ;sustain/release
          db    000h,000h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx1efq         ;frequency data
          dw    sfx1eout        ;carrier level data
          dw    130            ;keyoff time
          dw    200            ;end of sound time


sfx1efq    label word
          dw    240h,8000h      ;
sfx1efql   label word
          dw     190,7
          dw    0ffffh,sfx1efql  ;loop from beginning

sfx1eout   label byte
          db    30,80h      ;level, number of repeats
sfx1eoutl  label byte
          db    -4,5
          db    30,80h
          dw    0ffffh         ;loop
          dw    sfx1eoutl       ;loop point


;----------------------------------------------------------------------------
;'4'
sfx1fstart label sfxheader
          db    006h,001h      ;multi etc.
          db    010h,010h      ;level
          db    0f0h,0f4h      ;attack/decay
          db    0f0h,0f6h      ;sustain/release
          db    001h,001h      ;waveform
          db    000h           ;feedback/connection
          dw    sfx1ffq         ;frequency data
          dw    sfx1fout        ;carrier level data
          dw    40            ;keyoff time
          dw    60            ;end of sound time


sfx1ffq    label word
sfx1ffql   label word
          dw    240h,8000h      ;
          dw    100,14
          dw    0ffffh,sfx1ffql  ;loop from beginning

sfx1fout   label byte
          db    8,80h      ;level, number of repeats
sfx1foutl  label byte
          db    0,7fh
          dw    0ffffh         ;loop
          dw    sfx1foutl       ;loop point







IFNDEF STANDALONE

global getsfxseg:proc

.code
getsfxseg   proc
            mov   ax,seg SFX_DATA
            ret
getsfxseg   endp

ENDIF   ;STANDALONE

ENDIF   ;ENABLESFX
end
