;This include file defines the version of the code that is to be generated
;by the assembler.

SMFPVERSION        equ         0    ;not used. Could define the versions of
                                    ;SMFP files supported by the player.

;INSTRUMENT_SEARCH  equ         1   ;if defined, findfreevoice will search
                                    ;for a voice which has already uploaded
                                    ;the instrument which is needed for the
                                    ;new voice. Does not seem to bring down
                                    ;the maximum amount of time needed by
                                    ;the player, and also takes some of the
                                    ;spaceiousness away which comes with the
                                    ;last-used-first-technique otherwise used
                                    ;to select the next voice due for use.

;KEYOFF_ADSR        equ         1   ;if defined, ADSR curve will change
                                    ;at noteoff. Otherwise, it will remain
                                    ;the same as set at noteon time. This can
                                    ;be masked out if the values for keyon-
                                    ;and keyoff-ADSR are the same, possibly
                                    ;saving some outs here and there - while
                                    ;it does not seem to bring down the
                                    ;maximum time of the player.

STANDALONE         equ         1   ;if this is defined, all test
                                    ;code will be masked out, and the
                                    ;assembler will output object files
                                    ;suitable for linking into a final
                                    ;binary image.


                                    ;NOTE: The number of INs (6) and OUTs
                                    ;(42) specified in the following are
                                    ;implemented according to AdLib's
                                    ;recommendations.

AdLibIN1Repeat        equ     6     ;number of IN instructions after OUTing
                                    ;AdLib register
AdLibIN2Repeat        equ     42    ;number of IN instructions after OUTing
                                    ;AdLib value


MAXFRAMEEVENTCOUNT equ 15           ;Max. number of events to process in a
                                    ;single frame. If this number is exceded,
                                    ;the player will stop reading events,
                                    ;and the playback of the music file will
                                    ;become imprecise. The reduction of the
                                    ;value is the only way to ensure a
                                    ;maximum frame time regardless of the
                                    ;MIDI file being played.

NUMHWVOICES        equ 9            ;Number of hardware voices to use. This
                                    ;value should only be used temporarily,
                                    ;since the value is specified as a
                                    ;variable in the header of the SMFP file.
                                    ;Setting the number of voices to a value
                                    ;lower than 9 would make it possible to
                                    ;reserve one or more voices for other
                                    ;purposes (sound effects).

DRUM_MIN_PRIORITY  equ 10           ;Drum keys, or channels, with a priority number
                                    ;higher than or equal to this number
                                    ;will never be considered by the
                                    ;procedure "stealvoice" which takes a
                                    ;voice which is already in use but has
                                    ;the lowest priority of those in use.

ENABLESFX          equ 1            ;If this is defined, code is included
                                    ;to support the playback of sound fx.
REMAP_SFX          equ 1            ;If this is defined, code is included
                                    ;to support automatic triggering of
                                    ;multiple-sound sound effects. Has no
                                    ;effect if ENABLESFX is not defined.
